DECLARE SUB TextIn (ui$, prompt$, cur%, linelen%)
'A routine to substitute LINE INPUT. By Antoni Gual  agual@eic.ictnet.es
'--------------------------------------------------------------------------
' Allows input  to be aborted with ESC.
' Allows user input and cursor position to be initialized to not null
' Dos noes span to multi line. If input exceeds available space scrolls it!
' It interprets escape sequences in prompt as color codes
'   (The last color code in the prompt will apply to the input window..)
' It saves the active COLOR setting and restores it



'demo
e$ = CHR$(27)
clra$ = e$ + CHR$(16 * 0 + 9)
clrb$ = e$ + CHR$(16 * 0 + 12)
CLS

t$ = "c:\windows\"
PRINT "With LINE INPUT user input can span  multiple lines,you can't ESC or use colors"
LOCATE , 5: COLOR 14, 1
LINE INPUT "Input a string: "; a$
COLOR 7, 0
PRINT "The user input was: "; a$
PRINT

PRINT "Using TextIn with color prompt and pre-initialized string. You can ESC"
prompt$ = clra$ + "Input a String: " + e$ + CHR$(16 * 1 + 14)
LOCATE , 5
TextIn t$, prompt$, 0, 40
PRINT "The user input was: "; t$

t$ = "c:\widows\"
PRINT
PRINT "Using TextIn with an initialized cursor"
LOCATE , 5
TextIn t$, clra$ + "Please " + clrb$ + "correct: " + e$ + CHR$(16 * 1 + 14), 6, 40
PRINT "The user corrected to:", t$

DEFINT A-Z
SUB TextIn (ui$, prompt$, cur, linelen)

' Substitutes LINE INPUT. By Antoni Gual  agual@eic.ictnet.es
' PARAMETERS:--------------------------------------------------------------
' ui$:    Returns user input.Can be initialized. Can't include color codes
' prompt$: Prompt string. Can include color codes in the form chr$(27)+
'            chr$(background*16+foreground)
' cur:     It allows to initialize cursor position and returns the position
'            where cursor ended, or -1 if user aborted with ESC.
' linelen: Limits size of the prompt+user input window. If 0 it defaults to
'            screen width.
' FEATURES:----------------------------------------------------------------
' Allows input  to be aborted with ESC.
' Allows user input and cursor position to be initialized to not null
' Dos noes span to multi line. If input exceeds available space scrolls it!
' It interprets escape sequences in prompt as color codes
'   (The last color code in the prompt will apply to the input window..)
' It saves the active COLOR setting and restores it
'--------------------------------------------------------------------------
    col = POS(0)
    IF linelen > 81 - col OR linelen = 0 THEN linelen = 81 - col
   
    'save current active color to cfg, cbg
    LOCATE , col: PRINT " "; : LOCATE , col: clr = SCREEN(CSRLIN, POS(0), 1)
    cbg = clr / 16: cfg = clr MOD 16
   
    'parse colors in prompt and display it
    a1 = 1: lp = col + LEN(prompt$): e$ = CHR$(27)
    DO
      a = INSTR(a1, prompt$, e$)
      IF a THEN
          b = ASC(MID$(prompt$, a + 1, 1)): bg = b \ 16: fg = b MOD 16: lp = lp - 2
          PRINT MID$(prompt$, a1, a - a1); : COLOR fg, bg: a1 = a + 2
      END IF
    LOOP UNTIL a = 0 OR a1 > LEN(prompt$)
    PRINT MID$(prompt$, a1);
     
    'init
    txt$ = ui$
    lf = linelen - lp: c1$ = SPACE$(lf): ins = 1: topcur = 1: strt = 1
    IF cur = 0 OR cur > LEN(txt$) THEN cur = LEN(txt$) + 1
     
    'key input loop
    DO
   
        'display input string
        IF cur > lf + strt THEN strt = cur - lf + 1
        IF cur < strt THEN strt = cur
        kur = lp + cur - strt: LSET c1$ = MID$(txt$, strt)
        LOCATE , lp: PRINT c1$; : LOCATE , kur, 1, topcur, 16
           
        'get a key
        DO: k$ = INKEY$: LOOP UNTIL LEN(k$)
        ky = ASC(RIGHT$(k$, 1)): IF LEN(k$) = 2 THEN ky = -ky
           
        'modify txt$ on key read
        SELECT CASE ky
        CASE 32 TO 255
            IF cur > LEN(txt$) THEN
                txt$ = txt$ + CHR$(ky)
            ELSEIF cur = 1 THEN
                IF ins THEN txt$ = CHR$(ky) + MID$(txt$, cur) ELSE MID$(txt$, cur) = CHR$(ky)
            ELSE
                IF ins THEN
                    txt$ = LEFT$(txt$, cur - 1) + CHR$(ky) + MID$(txt$, cur)
                ELSE
                    MID$(txt$, cur) = CHR$(ky)
                END IF
            END IF
            cur = cur + 1
        CASE 8: IF cur > 1 THEN kur = cur - 1: GOSUB delete: cur = cur - 1
        CASE -83: IF cur <= LEN(txt$) THEN kur = cur: GOSUB delete
        CASE -75: IF cur > 1 THEN cur = cur - 1
        CASE -77: IF cur <= LEN(txt$) THEN cur = cur + 1
        CASE -82: ins = NOT ins: IF topcur = 1 THEN topcur = 16 ELSE topcur = 1
        CASE -71: cur = 1
        CASE -79: cur = LEN(txt$) + 1
        END SELECT

    LOOP UNTIL ky = 13 OR ky = 27
       
    PRINT
    IF ky = 27 THEN cur = -1 ELSE ui$ = txt$
    'reset original active color
    IF a THEN COLOR cfg, cbg
    EXIT SUB
delete: txt$ = LEFT$(txt$, kur - 1) + MID$(txt$, kur + 1): RETURN
END SUB

